;-- copy shapefile_utils.ncl from 
;-- https://www.ncl.ucar.edu/Applications/Scripts/shapefile_utils.ncl
load "shapefile_utils.ncl"; 

begin

shpname  = "NW.shp" 
maskname = "NW.nc" 

print_shapefile_info(shpname)

;-- open data file to get the grid to be used
f = addfile("jra55_JJA_1993m.nc","r")

;-- read variable
var                    =  f->sfctemp(0,:,:)

; var&g0_lat_1@units = "degrees_north"
; var&g0_lon_2@units = "degrees_east"
var@lat2d = f->g0_lat_1
var@lon2d = f->g0_lon_2

printVarSummary(var)
;-- shapefile mask resources 
opt             =  True
opt@return_mask =  True    ;-- this forces the return of a 0s and 1s mask array

;-- create the mask based on the given shapefile
mask_array             =  shapefile_mask_data(var, shpname, opt)
mask_array!0           = "y" 
mask_array!1           = "x" 
mask_array@coordinates = "g0_lat_1 g0_lon_2" 

;-- create new netCDF file and write mask array
system("rm -f " + maskname)
fout = addfile(maskname,"c")

fout->mask_array =  mask_array
fout->g0_lat_1       =  f->g0_lat_1
fout->g0_lon_2       =  f->g0_lon_2

end